﻿function SendEMail(Host, Username, Password: string; Port: integer; FromAddress, Recipient, Subject, Msg: string; FileName: string=''): boolean;
var
  LMsg: TIdMessage;
  IdSMTP: TIdSMTP;
  IdSSLIOHandlerSocketOpenSSL: TIdSSLIOHandlerSocketOpenSSL;
  slFiles: TStringList;
  i, c: integer;
  ar: array of String;
begin
  Result := False;

  LMsg := TIdMessage.Create(nil);

  try
      // FromAddress --------
      LMsg.From.Address := Trim(FromAddress);


      // Recipient -------
      if Pos(';', Recipient)=0 then LMsg.Recipients.Add.Address := Trim(Recipient) // one recipient
      else begin  // multiple recipients (separated by semicolons)
        ar := SplitString(Recipient, ';');
        c := Length(ar)-1;
        for i := 0 to c do
          if Pos('@',ar[i]) <> 0 then LMsg.Recipients.Add.Address := Trim(ar[i]);

        ar := nil;
      end;

      //LMsg.CCList.Add.Address := '';  // CC emails


      // Subject -------
      LMsg.Subject := Trim(Subject);



      // Files
      slFiles := TStringList.Create;
      try
          slFiles.Text := FileName;
    
          if slFiles.Count > 0 then
          begin
            LMsg.ContentType := 'multipart/mixed';
            for i := 0 to slFiles.Count-1 do
              if FileExists(slFiles[i]) then TIdAttachmentFile.Create(LMsg.MessageParts, slFiles[i]);
          end
          else LMsg.ContentType := 'text/plain'; //'text/plain; charset=UTF-8;';
      finally
          slFiles.Free;
      end;


      // Message -------
      LMsg.Body.Text := Msg;
      LMsg.CharSet:='UTF-8';                             


      // SSL Settings
      IdSSLIOHandlerSocketOpenSSL := TIdSSLIOHandlerSocketOpenSSL.Create(nil);
      IdSSLIOHandlerSocketOpenSSL.Destination := Trim(Host)+':'+IntToStr(Port);
      IdSSLIOHandlerSocketOpenSSL.Host := Trim(Host);
      IdSSLIOHandlerSocketOpenSSL.Port := Port;
      IdSSLIOHandlerSocketOpenSSL.DefaultPort := 0;
      IdSSLIOHandlerSocketOpenSSL.SSLOptions.Method := sslvTLSv1; //sslvSSLv2, sslvSSLv23, sslvSSLv3, sslvTLSv1, sslvTLSv1_1, sslvTLSv1_2
      IdSSLIOHandlerSocketOpenSSL.SSLOptions.Mode := sslmUnassigned; //sslmUnassigned, sslmClient, sslmServer, sslmBoth
      //IdSSLIOHandlerSocketOpenSSL.SSLOptions.VerifyMode := 0;
      //IdSSLIOHandlerSocketOpenSSL.SSLOptions.VerifyDepth := 0;


      // Sending
      IdSMTP := TIdSMTP.Create(nil);
      IdSMTP.IOHandler := TidIOHandler(IdSSLIOHandlerSocketOpenSSL);
      try

          try
            IdSMTP.Host := Trim(Host);
            IdSMTP.Username := Username;
            IdSMTP.Password := Password;
            IdSMTP.Port := Port;
            IdSMTP.ConnectTimeout := 5000;
            IdSMTP.ReadTimeout := 3000;

            IdSMTP.UseTLS :=  utUseExplicitTLS;
                // utNoTLSSupport,
                // utUseImplicitTLS, // ssl iohandler req, allways tls
                // utUseRequireTLS, // ssl iohandler req, user command only accepted when in tls
                // utUseExplicitTLS // < user can choose to use tls


            IdSMTP.Connect;
            IdSMTP.Send(LMsg);
            IdSMTP.Disconnect;


            Result := True;
          except
            ShowMessage(ExceptionMessage);
          end;

      finally
        IdSSLIOHandlerSocketOpenSSL.Free;
        IdSMTP.Free;
      end;                                                                           


    finally
      LMsg.Free;
    end;


end;


procedure Form1_Button1_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if SendEMail('smtp.gmail.com', 'username', 'password', 465, 'yourmail@mail.com', 'recipient@mail.com', 'Subject', 'Hello', 'd:\filename1.ext'+#10#13+'d:\filename2.ext') then ShowMessage('Sent') else ShowMessage('Failed');
end;


begin

end.
